﻿using System;
using System.Text;

namespace RTTrick.Helpers
{
    public static class DumpMemory
    {
        public static unsafe string CreateDumpString(void* p, long len)
        {
            var sb = new StringBuilder();
            var pByte = (Byte*)p;

            for (int offset = 0; offset < len; offset++)
            {
                sb.Append($"{*(pByte + offset):X2}");

                if (offset != 0)
                {
                    if (offset % 16 == 0)
                        sb.AppendLine();
                    else if (offset % 8 == 0)
                        sb.Append(" ");
                }
            }

            return sb.ToString();
        }
    }
}
