﻿using System;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace RTTrick.Internals
{
    /// <summary>
    /// CLR 오브젝트의 헤더 부분
    /// </summary>
    [StructLayout(LayoutKind.Sequential)]
    internal unsafe struct ObjectHeader
    {
        private MethodTable* _methodTablePointer;

        /// <summary>
        /// 클래스 타입의 변수를 ObjectHeader*로 변경하는 메서드
        /// </summary>
        public static ObjectHeader* CreateObjectHeader<T>(ref T obj) where T : class
        {
            var ppObj = (ObjectHeader**)Unsafe.AsPointer(ref obj);
            return *ppObj;
        }

        public MethodTable* GetMethodTable()
        {
            return _methodTablePointer;
        }

        public int GetObjectSize()
        {
            throw new NotImplementedException();
        }
    }
}
